// MD-R
// version 1.0
// September 03, 2015
// Author: Vi Q. Ha

/// Notes: 
/// This is a template on how to create a customized Thermostat function
/// This example applies the Berendsen Thermostat
/// Users will only need to change where there's a "[INSTRUCTION]:" tag
/// Everything else is meant to be left alone.
#ifndef VMD_THERMO_TEMPL
#define VMD_THERMO_TEMPL


#include "pairPotential.h"

#include "thermo.h"
class CustomThermostats : public mdr::Thermo
{
    private:
		
    public:
		CustomThermostats(mdr::MDR * _vmd):mdr::Thermo(_vmd){}
		void apply();

};


void CustomThermostats::apply(){
	

	int nMol = parameters->nTotal;
	double deltaT = parameters->deltaT;
	double temperature = parameters->desired_temperature;
	
	double vvSum = get_vvSum_GLOBAL();
	/// Math and stuff:
	double couplingConstant = berendsenCoupl * deltaT;
	double realTemp = (double) vvSum / (nMol * 3.);
	double vFac = sqrt(1. + deltaT/couplingConstant * (temperature / realTemp - 1));
	
	std::set<AGENT_TYPE*> agents;
	context->selectAgents(repast::SharedContext<AGENT_TYPE>::LOCAL, context->size(), agents);
	std::set<AGENT_TYPE*>::iterator agentToEval = agents.begin();

	while(agentToEval != agents.end()){
		
		/// [INSTRUTIONS]: /////////////////////////////////////////////
		/// scaling particles' kinetic energy
		(*agentToEval)->velocity = ( (*agentToEval)->velocity) * vFac;
		agentToEval++;
	}
	

}
#endif
